
local StoneGateV5 = ...


-- Apply building asset processor
StoneGateV5:registerAssetProcessor("models/machicolations/machicolationKeepPlatform.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/machicolations/machicolationCrenation.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/machicolations/machicolationMainPlatform.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/machicolations/machicolationSmallSquaredTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/machicolations/machicolationSmallGate.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/machicolations/machicolationOctogonalTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

function registerMachicolationPart(_nameSize, _nameFbx, _nameAsset, _buildingZone)
    StoneGateV5:registerAssetId("models/machicolations/" .. _nameSize .. ".fbx/Prefab/machicolation/" .. _nameFbx .. "Part", "STONE_GATE_V5_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set machicolation platform part
    StoneGateV5:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_" .. _nameAsset .. "_PART",
	Name = "STONE_GATE_V5_" .. _nameAsset .. "_NAME",
	Description = "STONE_GATE_V5_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V5_" .. _nameAsset .. "_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	}
    })

    StoneGateV5:registerPrefabComponent("models/machicolations/" .. _nameSize .. ".fbx/Prefab/machicolation/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the roofs)
	BuildingZone = _buildingZone
    })
end

registerMachicolationPart( "machicolationKeepPlatform", "step_4_Keep_MachicolationC", "MACHICOLATION_KEEP_C", { 8, 8 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation34", "MACHICOLATION_CRENATION34", { 2, 8 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation40R", "MACHICOLATION_CRENATION40R", { 2, 8 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation40L", "MACHICOLATION_CRENATION40L", { 2, 8 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation50", "MACHICOLATION_CRENATION50", { 2, 8 } )
registerMachicolationPart( "machicolationKeepPlatform", "step_6_Keep_MachicolationRoofC", "MACHICOLATION_KEEP_ROOF_C", { 8, 8 } )
registerMachicolationPart( "machicolationMainPlatform", "step_4_Main_MachicolationD", "MACHICOLATION_MAIN_D", { 8, 12 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation54", "MACHICOLATION_CRENATION54", { 2, 12 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation60R", "MACHICOLATION_CRENATION60R", { 2, 12 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation60L", "MACHICOLATION_CRENATION60L", { 2, 12 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation70", "MACHICOLATION_CRENATION70", { 2, 12 } )
registerMachicolationPart( "machicolationMainPlatform", "step_6_Main_MachicolationRoofD", "MACHICOLATION_MAIN_ROOF_D", { 8, 12 } )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationA", "MACHICOLATION_SST_RAMPART_A", { 4, 4 } )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationB", "MACHICOLATION_SST_RAMPART_B", { 4, 4 } )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMA", "MACHICOLATION_SST_ROOF_A", { 4, 4 } )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMB", "MACHICOLATION_SST_ROOF_B", { 4, 4 } )
registerMachicolationPart( "machicolationSmallGate","step_4_SGate_MachicolationA", "SGATE_MACHICOLATION_A", { 0, 0 } )
registerMachicolationPart( "machicolationSmallGate","step_5_SGate_MachicolationClosingL", "SGATE_MACHICOLATION_CLOSING_L", { 0, 0 } )
registerMachicolationPart( "machicolationSmallGate","step_5_SGate_MachicolationClosingR", "SGATE_MACHICOLATION_CLOSING_R", { 0, 0 } )
registerMachicolationPart( "machicolationSmallGate","step_4_SGate_WoodenRoofA", "SGATE_MACHICOLATION_WOODEN_ROOF_A", { 0, 0 } )
registerMachicolationPart( "machicolationSmallGate","step_4_SGate_StoneRoofA", "SGATE_MACHICOLATION_STONE_ROOF_A", { 0, 0 } )
registerMachicolationPart( "machicolationOctogonalTower","step_4_Octogonal_Machicolation", "OTOWER_MACHICOLATION", { 9, 9 } )
registerMachicolationPart( "machicolationOctogonalTower","step_6_Octogonal_MachicolationRoof", "OTOWER_MACHICOLATION_ROOF", { 9, 9 } )
